Gamma.mle <- function(xx){
    s  = log(mean(xx)) - mean(log(xx))
    k0 = (3 - s + sqrt((s-3)^2 + 24*s)) / (12*s)
    nx = length(xx)
    lk <- function(k){
        (1-k)*sum(log(xx))+nx*k+nx*k*log(mean(xx))-nx*k*log(k)+nx*log(gamma(k))
    }
    
    m = nlm(lk, k0)
    
    khat = m$estimate
    logL = -m$minimum
    
    if(m$code > 2){
        warning("cannot find mle of k in tGamma.mle\n")
    }
    
    theta = mean(xx) / khat
    list(k = khat, s = theta, logL = logL)
}
