"emiss" <-
function(xk, pk, x.fix, p.fix, state, penalty="BIC", b.limit=0.001)
{    
    n   = length(xk)

    em = numeric(4)

    if(state[1] || state[2]){
        sd.x  = sqrt(sum((xk - x.fix)^2)/n)
        em[1] = em[2] = sum(dnorm(xk, x.fix, sd.x, log=TRUE))
    }
    if(state[3] || state[4]){
        # ----------------------------------------------------------
        # state 3 or 4, line with slope
        #
        # x = a + b*p             (1)
        # x.bar = a + b*p.bar     (2)
        # x.fix = a + b*p.fix     (3)
        # 
        # (1) + (2) => x-x.bar = b*(p - p.bar)
        # (1) + (3) => x-x.fix = b*(p - p.fix)
        # ----------------------------------------------------------
        
        nx = xk - x.fix
        np = pk - p.fix
        
        ## s is estimation of slope b
        s = sum(nx*np)/sum(np*np)
        b = s
        if(s >= 0 && s <= b.limit){ b = b.limit }
        if(s <  0 && s > -b.limit){ b = -b.limit }    
        
        if(is.null(penalty)){
            penalt = 0;        
        }else if(penalty=="BIC"){
            penalt = - 0.5*log(n)
        }else if(penalty=="AIC"){
            penalt = - 1
        }else{
            stop("unknown penalty specification")
        }

        if(!state[4]){
            ## if only calculate emission probability of state 3
            if(s>=0){
                em[3] = -1/0
            }else{
                resid = nx - b*np
                sd.re = sum(resid^2)/n
                em[3] = sum(dnorm(resid, 0, sd.re, log=TRUE)) - penalt
            }
        } 
        if(!state[3]){
            ## if only calculate emission probability of state 4
            if(s<=0){
                em[4] = -1/0
            }else{
                resid = nx - b*np
                sd.re = sum(resid^2)/n
                em[4] = sum(dnorm(resid, 0, sd.re, log=TRUE)) - penalt
            }
        }
        if(state[3] && state[4]){
            ## calculate emission probability of both state 3 and 4
            resid = nx - b*np
            sd.re = sum(resid^2)/n
            if(s>=0){
                em[3] = -1/0
                em[4] = sum(dnorm(resid, 0, sd.re, log=TRUE)) - penalt
            }else{
                em[4] = -1/0
                em[3] = sum(dnorm(resid, 0, sd.re, log=TRUE)) - penalt
            }
        }
    }
    return(em)

}

