setwd("/Users/wei/Softwares/R/hmm.linear/_R_new")

source("emiss.R")

n = 5
x = rnorm(n)
p = seq(4, 4*n, by=4)

adj      = sqrt((n-1)/n)
x.fix    = NULL
p.fix    = NULL
b.limit  = 1/1000
log.zero = -100

emiss(x, p, x.fix=x.fix, p.fix=p.fix, c(1,0,0,0))
emiss(x, p, x.fix=x.fix, p.fix=p.fix, c(0,1,0,0))
emiss(x, p, x.fix=x.fix, p.fix=p.fix, c(0,0,1,0))
emiss(x, p, x.fix=x.fix, p.fix=p.fix, c(0,0,0,1))
emiss(x, p, x.fix=x.fix, p.fix=p.fix, c(0,0,1,1))

if(is.null(x.fix)){
    mean.x = mean(x)
    sd.x   = sd(x)*adj
}else{
    mean.x = x.fix
    sd.x   = sqrt(sum((x-x.fix)^2)/n)
}

sum(dnorm(x, mean.x, sd.x, log=TRUE))

if(is.null(x.fix)) x.fix = mean(x)
if(is.null(p.fix)) p.fix = mean(p)

nx = x - x.fix
np = p - p.fix

l = lm(nx ~ -1+np)
b = l$coef[1]
if(b>0 && b<b.limit)
    b = b.limit
if(b<0 && b>-b.limit)
    b = -b.limit
resid = nx - b*np

sum(dnorm(resid, 0, sd.x, log=TRUE)) - 0.5*log(n)
