\name{Gamma.mle}
\alias{Gamma.mle}
\title{ mle of parameters of Gamma distribution }
\description{
  Find Maximum Likelihood Estimation of parameters of Gamma distribution
}
\usage{
Gamma.mle(xx)
}
\arguments{
  \item{xx}{ data, which are suppose to follow Gamma distribution }
}
\details{
  Notation: the density of Gamma: f(x)= 1/(s^k Gamma(k)) x^(k-1) e^-(x/s)
}
\value{
  a list
  \item{k }{ shape parameter of Gamma distribution }
  \item{s }{ scale parameter of Gamma distribution }
  \item{logL }{ log Likelihood }
}
\references{ http://en.wikipedia.org/wiki/Gamma_distribution }
\author{ Wei Sun sunwei@stat.ucla.edu }
\note{ }

\examples{

    xx  = rgamma(6000, shape=1.6, scale=600)
    est = Gamma.mle(xx)
    est
    
    z = dgamma(1:round(max(xx)), shape=est$k, scale=est$s)
    d = density(xx)
    y.max = max(max(d$y),max(z))
    br = seq(0, ceiling(max(xx)/200)*200, by=200)
    hist(xx, ylim=c(0, y.max), breaks=br, freq=FALSE, main="")
    lines(1:round(max(xx)), z, col="orange")

}
\keyword{ utilities }
