\name{backward}
\alias{backward}
\title{ calculate backward probability }
\description{
  calculate backward probability: b(i, t1, t2) = P($x_{stp_end(t2)+1}$, ..., $x_n$ | $S_i$ at step t1:t2, $\Lambda$)
}
\usage{
backward(x, p, a, du, step, x.end, x.end.idx, penalty = "BIC", b.limit = 0.001, cut=0.5)
}
\arguments{
  \item{x}{ a vector of observations }
  \item{p}{ a vector of the same length as x, indicating the positions(time) of observations x }
  \item{a}{ transition matrix }
  \item{du}{ duration probability matrix }
  \item{step}{ length of one step }
  \item{x.end}{ x value at the end of each possible segment, can be calculated using function get.ends }
  \item{x.end.idx}{ indicators that indicate whether one segment is possible or not }
  \item{penalty}{ penalty used while calculating likelihood }
  \item{b.limit}{ if the segmental model of one segment is linear model with a slope, b.limit is the minimum absolute value of the slope }
  \item{cut}{cutting point used in function logsumexp}
}
\details{
}
\value{
  a list \code{b}, let bi = b[[i]], 
  bi[t1][t2] = Prob($x_{stp_end(t2)+1}$, ..., $x_n$ | $S_i$ at step t1:t2, $\Lambda$)
}
\references{ Rabiner L: A tutorial on hidden Markov models and selected applications in speech recognition. Proceedings of the IEEE 1989, 77(2):257-286.
}
\author{ Wei Sun sunwei@stat.ucla.edu }
\note{ }

\examples{

}
\keyword{ methods }
