\name{emiss}
\alias{emiss}
\title{ emission probability }
\description{
  calculate emission probability
}
\usage{
emiss(xk, pk, x.fix, p.fix, state, penalty = "BIC", b.limit = 0.001)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{xk}{ a vector of observations }
  \item{pk}{ a vector of the same length as x, indicating the positions/time of observations x }
  \item{x.fix}{ fix value of x, the estimated segmental model must pass the point (p.fix, x.fix) }
  \item{p.fix}{ fix value of p, the estimated segmental model must pass the point (p.fix, x.fix)}
  \item{state}{ a vector of length m, indicating the emission probability of which state we want to calculate. For example, if we want to calculate emission probability of the first two sates, we can set \code{state}=c(1,1,0,0)}
  \item{penalty}{ the number of parameters of different segmental model may different, \code{penalty} specify how to penalize those segmental models with more parameters }
  \item{b.limit}{ if the segmental model of one segment is linear model with a slope, b.limit is the minimum absolute value of the slope }
}
\details{
This emission probability calculation specifically use four states:
    \item{state 1}{ long flat line }
    \item{state 2}{ short flat line }
    \item{state 3}{ line of negative slope, followed by state 2 }
    \item{state 4}{ line of positive slope, followed by state 1)}
}
\value{
    ev: a vector of length 4, ev[i] = emission probability for state i.
}
\references{  }
\author{ Wei Sun sunwei@stat.ucla.edu }
\note{ 
 the emission probabilities in function forward, backward and viterbi are actually calculated by a c function emiss instead of this R function, though these two functions do the same calculation.
 }

\examples{

}
\keyword{ utilities }
